various fixes for bullseye and new ssh key changes
[automated-distro-installer] / fai / config / hooks / partition.DEFAULT
index 61da95a3f4162d003d6476fbc61a88ff35b32932..80f0d7c4a70afd9dfb86f616c7830089bb06bcc3 100755 (executable)
@@ -26,16 +26,17 @@ fi
 
 # for calling outside of FAI:
 # fai-redep
-# s
+#
 # source /b/fai/fai-wrapper
 # - set any appropriate classes with: fai-setclass OPT1... which sets CLASS_OPT1=true...
 #   or run eval-fai-classfile FILE.
-# - Set a VOL_DISTROVER, eg:
+# - Set a VOL_DISTROVER (if not doing mkroot2) eg:
 #   fai-setclass VOL_NABIA
-# - export luks_dir=/q/root/luks
 #
 # OPTIONS:
 #
+# mkroot2: for running outside of fai and setting up the root2/boot2 luks and btrfs
+#
 # environment variables:
 #
 # HOSTNAME: if frodo, we exclude 2 devices from the /boot array, which
@@ -63,6 +64,20 @@ fi
 # raid10.
 # RAID1: forces raid1 filesystem.
 
+mkroot2=false
+if [[ $1 ]]; then
+  case $1 in
+    mkroot2)
+      mkroot2=true
+      ;;
+    *)
+      echo "$0: error: unsupported arg: $1" >&2
+      exit 1
+      ;;
+  esac
+fi
+
+
 if [[ $SPECIAL_DISK ]]; then
   export CLASS_REPARTITION=true
 fi
@@ -94,18 +109,30 @@ fi
 
 #### begin configuration
 
+# this is the ordering of the /dev/sdaX, but
+# the ordering of the partition layout goes like this:
+# bios_grub
+# grub_ext
+# efi
+# root
+# swap
+# boot
+
 rootn=1
-swapn=2
-bootn=3
-efin=4
+root2n=2
+swapn=3
+bootn=4
+boot2n=5
+efin=6
 # ext partition so grub can write persistent variables,
 # so it can do a one time boot. grub can't write to
 # btrfs or any cow fs because it's more
 # more complicated to do and they don't want to.
-grub_extn=5
+grub_extn=7
 # bios boot partition,
 # https://wiki.archlinux.org/index.php/GRUB
-bios_grubn=6
+bios_grubn=8
+even_bign=9
 lastn=$bios_grubn
 
 
@@ -114,7 +141,7 @@ lastn=$bios_grubn
 
 
 add-part() { # add partition suffix to $dev
-  local d ret
+  local d part
   if [[ $# == 1 ]]; then
     d=$dev
     part=$1
@@ -125,25 +152,56 @@ add-part() { # add partition suffix to $dev
   echo $d-part$part
 }
 
-bootdev() { add-part $@ $bootn; }
 rootdev() { add-part $@ $rootn; }
+root2dev() { add-part $@ $root2n; }
 swapdev() { add-part $@ $swapn; }
+bootdev() { add-part $@ $bootn; }
+boot2dev() { add-part $@ $boot2n; }
 efidev() { add-part $@ $efin; }
 grub_extdev() { add-part $@ $grub_extn; }
 bios_grubdev() { add-part $@ $bios_grubn; }
+even_bigdev() { add-part $@ $even_bign; }
 
 crypt-dev() { echo /dev/mapper/crypt_dev_${1##*/}; }
 crypt-name() { echo crypt_dev_${1##*/}; }
 root-cryptdev() { crypt-dev $(rootdev $@); }
+root2-cryptdev() { crypt-dev $(root2dev $@); }
 swap-cryptdev() { crypt-dev $(swapdev $@); }
 root-cryptname() { crypt-name $(rootdev $@); }
+root2-cryptname() { crypt-name $(root2dev $@); }
 swap-cryptname() { crypt-name $(swapdev $@); }
 
 dev-mib() {
-  echo $(( $(parted -m $dev unit MiB print | \
+  local d=${1:-$dev}
+  echo $(( $(parted -m $d unit MiB print | \
                sed -nr "s#^/dev/[^:]+:([0-9]+).*#\1#p") - 1))
 }
 
+luks-setup() {
+  local luksdev="$1"
+  # when we move to newer than trisquel 9, we can remove
+  # --type luks1. We can also check on cryptsetup --help | less /compil
+  # to see about the other settings. Default in debian 9 is luks2.
+  # You can convert from luks2 to luks 1 by adding a temporary key:
+  # cryptsetup luksAddKey --pbkdf pbkdf2
+  # then remove the new format keys with cryptsetup luksRemoveKey
+  # then cryptsetup convert DEV --type luks1, then readd old keys and remove temp.
+  yes YES | cryptsetup luksFormat $luksdev $luks_file || [[ $? == 141 ]]
+  yes "$lukspw" | \
+    cryptsetup luksAddKey --key-file $luks_file \
+               $luksdev || [[ $? == 141 ]]
+  # background: Keyfile and password are treated just
+  # like 2 ways to input a passphrase, so we don't actually need to have
+  # different contents of keyfile and passphrase, but it makes some
+  # security sense to a really big randomly generated passphrase
+  # as much as possible, so we have both.
+  #
+  # This would remove the keyfile.
+  #    yes 'test' | cryptsetup luksRemoveKey /dev/... \
+    #                            /key/file || [[ $? == 141 ]]
+  cryptsetup luksOpen $luksdev $(crypt-name $luksdev) --key-file $luks_file
+}
+
 ##### end function defs
 
 if ifclass REPARTITION; then
@@ -157,12 +215,12 @@ else
   wipe=true
 fi
 
-if ((`nproc` > 2)); then
+if (($(nproc) > 2)); then
   mopts=,compress=zstd
 fi
 
 declare -A disk_excludes
-if ! ifclass USE_MOUNTED; then
+if ! $mkroot2 && ! ifclass USE_MOUNTED; then
   ## ignore disks that are mounted, eg when running from fai-cd
   while read -r l; do
     eval "$l"
@@ -206,7 +264,7 @@ for dev in ${short_devs[@]}; do
   if $partition; then break; fi
   y=$(readlink -f $dev)
   arr=($y?*)
-  if (( ${#arr[@]}  != lastn )); then
+  if (( ${#arr[@]} < lastn )); then
     partition=true
   fi
   # On one system, blkid is missing some partitions.
@@ -236,6 +294,7 @@ fi
 boot_space=0
 first=true
 boot_devs=()
+boot2_devs=()
 for dev in ${devs[@]}; do
   if ifclass frodo; then
     # I ran into a machine where the bios doesn't know about some disks,
@@ -261,11 +320,15 @@ for dev in ${devs[@]}; do
         break
       fi
     done
-    $bad_disk || boot_devs+=($(bootdev))
+    if ! $bad_disk; then
+      boot_devs+=($(bootdev))
+      boot2_devs+=($(boot2dev))
+    fi
   else
     boot_space=$(( boot_space + $(parted -m $dev unit MiB print | \
                                     sed -nr "s#^/dev/[^:]+:([0-9]+).*#\1#p") - 1))
     boot_devs+=($(bootdev))
+    boot2_devs+=($(boot2dev))
   fi
   if $first && [[ $boot_devs ]]; then
     first_efi=$(efidev)
@@ -297,31 +360,42 @@ if (( boot_space > 60000 )); then
   # becuase I keep a minimal debian install on it for
   # recovery needs and for doing pxe-kexec.
   boot_mib=10000
-elif (( boot_space > 30000 )); then
+  root2_mib=200000
+  boot2_mib=2000
+elif (( boot_spa_ce > 30000 )); then
   boot_mib=$(( 5000 + (boot_space - 30000) / 2 ))
+  root2_mib=100
+  boot2_mib=100
 else
   # Small vms don't have room for /boot recovery.  With 3 kernels
   # installed, i'm using 132M on t8, so this seems like plenty of
   # room. note: rhel 8 recomments 1g for /boot.
   boot_mib=500
-  #
+  root2_mib=100
+  boot2_mib=100
 fi
 case $raid_level in
-  1*) boot_mib=$(( boot_mib * 2 )) ;;
+  1*)
+    boot_mib=$(( boot_mib * 2 ))
+    boot2_mib=$(( boot2_mib * 2 ))
+    root2_mib=$(( root2_mib * 2 ))
+    ;;
 esac
 ### end calculate boot partition space
 
 
 
 if [[ ! $DISTRO ]]; then
-  if ifclass VOL_BUSTER_BOOTSTRAP; then
-    DISTRO=debianbuster_bootstrap
+  if ifclass VOL_BULLSEYE_BOOTSTRAP; then
+    DISTRO=debianbullseye_bootstrap
   elif ifclass VOL_STRETCH; then
     DISTRO=debianstretch
   elif ifclass VOL_BUSTER; then
     DISTRO=debianbuster
   elif ifclass VOL_BULLSEYE; then
     DISTRO=debianbullseye
+  elif ifclass VOL_BOOKWORM; then
+    DISTRO=debianbookworm
   elif ifclass VOL_TESTING; then
     DISTRO=debiantesting
   elif ifclass VOL_XENIAL; then
@@ -336,6 +410,8 @@ if [[ ! $DISTRO ]]; then
     DISTRO=trisqueletiona
   elif ifclass VOL_NABIA; then
     DISTRO=trisquelnabia
+  elif $mkroot2; then
+    :
   else
     echo "PARTITIONER ERROR: no distro class/var set" >&2
     exit 1
@@ -355,6 +431,13 @@ bpart() { # btrfs a partition
 if [[ ! $luks_dir ]]; then
   # see README for docs about how to create these
   luks_dir=$FAI/distro-install-common/luks
+  if [[ ! -d $luks_dir ]]; then
+    luks_dir=/q/root/luks
+  fi
+  if [[ ! -d $luks_dir ]]; then
+    echo "$0: error: no luks_dir found" >&2
+    exit 1
+  fi
 fi
 
 luks_file=$luks_dir/host-$HOSTNAME
@@ -392,8 +475,36 @@ for dev in ${devs[@]}; do
   root_devs+=($(rootdev))
 done
 shopt -s nullglob
-if $partition; then
 
+# We write to these files instead of just /etc/fstab, /etc/crypttab,
+# because these are filesystems created after our current root, and so
+# this allows us to update other root filesystems too.
+rm -f /mnt/root/root2-{fs,crypt}tab
+if $mkroot2; then
+  if $partition; then
+    echo $0: error: found partition=true but have mkroot2 arg
+    exit 1
+  fi
+  for dev in ${devs[@]}; do
+    luks_file=$luks_dir/host-amy
+    lukspw=$(cat $luks_dir/amy)
+    luks-setup $(root2dev)
+    cat >>/mnt/root/root2-crypttab <<EOF
+$(root2-cryptname) $(root2dev)  $luks_file  discard,luks,initramfs
+EOF
+  done
+  bpart $(for dev in ${devs[@]}; do root2-cryptdev; done)
+  bpart ${boot2_devs[@]}
+  mkdir -p /mnt/root2 /mnt/boot2
+  cat >>/mnt/root/root2-fstab <<EOF
+$(root2-cryptdev ${devs[0]}) /mnt/root2  btrfs  nofail,x-systemd.device-timeout=30s,x-systemd.mount-timeout=30s,noatime,subvolid=0$mopts  0 0
+${boot2_devs[0]} /mnt/boot2  btrfs    nofail,x-systemd.device-timeout=30s,x-systemd.mount-timeout=30s,noatime,subvolid=0  0 0
+EOF
+  exit 0
+fi
+
+
+if $partition; then
   ### begin wipefs
   if [[ ! $SPECIAL_DISK ]]; then
     for dev in ${devs[@]}; do
@@ -415,13 +526,23 @@ if $partition; then
   ### end wipefs
 
 
+  # When we have 2 disks of at least 100g difference in size,
+  # make an extra partition on the end of the bigger one.
+  even_big_part=false
+  even_diff_min=100000
   if $even_raid; then
-    for dev in ${devs[@]}; do
-      cur_mib=$(dev-mib)
-      if [[ ! $disk_mib ]] || (( cur_mib < disk_mib )); then
-        disk_mib=$cur_mib
-      fi
-    done
+    smalli=0
+    bigi=1
+    if (( $(dev-mib ${devs[0]}) >= $(dev-mib ${devs[1]}) )); then
+      smalli=1
+      bigi=0
+    fi
+    disk_mib=$(dev-mib ${devs[smalli]})
+    even_big_dev=${devs[bigi]}
+    even_big_mib=$(dev-mib $even_big_dev)
+    if (( even_big_mib - disk_mib > even_diff_min )); then
+      even_big_part=true
+    fi
   fi
 
   for dev in ${devs[@]}; do
@@ -438,23 +559,38 @@ if $partition; then
     if ! $even_raid; then
       disk_mib=$(dev-mib)
     fi
-    root_end=$(( disk_mib - swap_mib - boot_mib /  ${#boot_devs[@]} ))
-    swap_end=$(( root_end + swap_mib))
+
+    boot_part_mib=$(( boot_mib / ${#boot_devs[@]} ))
+    boot2_part_mib=$(( boot2_mib / ${#boot_devs[@]} ))
+    root2_part_mib=$(( root2_mib / ${#root_devs[@]} ))
+    root_end=$(( disk_mib - root2_part_mib - swap_mib - boot_part_mib - boot2_part_mib ))
+    root2_end=$(( root_end + root2_part_mib ))
+    swap_end=$(( root2_end + swap_mib ))
+    boot_end=$(( swap_end + boot_part_mib ))
 
     parted -s $dev mklabel gpt
     # MiB because parted complains about alignment otherwise.
     pcmd="parted -a optimal -s -- $dev"
+    # root partition, the main big one
     $pcmd mkpart primary ext3 524MiB ${root_end}MiB
     # without naming, systemd gives us misc errors like:
     # dev-disk-by\x2dpartlabel-primary.device: Dev dev-disk-by\x2dpartlabel-primary.device appeared twice
     $pcmd name $rootn root
+    # root2 partition
+    $pcmd mkpart primary ext3 ${root_end}MiB ${root2_end}MiB
+    $pcmd name $root2n root2
     # normally a swap is type "linux-swap", but this is encrypted swap. using that
     # label will confuse systemd.
-    $pcmd mkpart primary "" ${root_end}MiB ${swap_end}MiB
+    # swap partition
+    $pcmd mkpart primary "" ${root2_end}MiB ${swap_end}MiB
     $pcmd name $swapn swap
-    $pcmd mkpart primary "" ${swap_end}MiB ${disk_mib}MiB
+    # boot partition
+    $pcmd mkpart primary "" ${swap_end}MiB ${boot_end}MiB
     $pcmd name $bootn boot
-    # eufi = bloated, half a gig gimme a break.
+    # boot2 partition
+    $pcmd mkpart primary "" ${boot_end}MiB ${disk_mib}MiB
+    $pcmd name $boot2n boot2
+    # uefi partition. efi sucks, half a gig, rediculous.
     $pcmd mkpart primary "fat32" 12MiB 524MiB
     $pcmd name $efin efi
     $pcmd set $efin esp on
@@ -462,20 +598,27 @@ if $partition; then
     # but not mentioned https://wiki.archlinux.org/index.php/EFI_system_partition
     # probably not needed
     $pcmd set $bootn boot on
+    $pcmd set $boot2n boot on
     # i only need a few k, but googling min size,
     # I found someone saying that gparted required
     # required at least 8 because of their hard drive cylinder size.
     # And 8 is still very tiny.
+    # grub_ext partition
     $pcmd mkpart primary "ext2" 4MiB 12MiB
     $pcmd name $grub_extn grubext
     # gpt ubuntu cloud image uses ~4 mb for this partition. fai uses 1 MiB.
     # so, I use 3, whatever.
     # note: parted manual saying cheap flash media
     # should to start at 4.
+    # biols grub partition
     $pcmd mkpart primary "" 1MiB 4MiB
     $pcmd name $bios_grubn biosgrub
     $pcmd set $bios_grubn bios_grub on
-    $pcmd set $bootn boot on # generally not needed on modern systems
+    if $even_big_part  && [[ $dev == "$even_big_dev" ]]; then
+      $pcmd mkpart primary ext3 ${disk_mib}MiB ${even_big_mib}MiB
+      $pcmd name $even_bign even_big
+    fi
+
     # the mkfs failed before on a vm, which prompted me to add
     # sleep .1
     # then it failed again on a physical machine
@@ -485,15 +628,20 @@ if $partition; then
     # Then I added the mkfs.ext2, which claimed to succeed,
     # but then couldn't be found upon reboot. In that case we didn't
     # wait at all. So I've added a 3 second minimum wait.
-    sleep 3
     secs=0
-    while [[ ! -e $(rootdev) ]] && (( secs < 10 )); do
+    while [[ ! -e $(bios_grubdev) ]] && (( secs < 10 )); do
       sleep 1
       secs=$((secs +1))
     done
+    sleep 3
 
     mkfs.fat -F32 $(efidev)
 
+    if $even_big_part  && [[ $dev == "$even_big_dev" ]]; then
+      luks-setup $(even_bigdev)
+      mkfs.btrfs -f $(crypt-dev $(even_bigdev))
+    fi
+
     # Holds just a single file, rarely written, so
     # use ext2, like was often used for the /boot partition.
     # This exists because grub can only persist data to a non-cow fs.
@@ -503,30 +651,7 @@ if $partition; then
     # This is just a bit more robust, and it could work for booting
     # into ipxe which can't persist data, if we ever got that working.
     mkfs.ext2 $(grub_extdev)
-    # when we move to newer than trisquel 9, we can remove
-    # --type luks1. We can also check on cryptsetup --help | less /compil
-    # to see about the other settings. Default in debian 9 is luks2.
-    # You can convert from luks2 to luks 1 by adding a temporary key:
-    # cryptsetup luksAddKey --pbkdf pbkdf2
-    # then remove the new format keys with cryptsetup luksRemoveKey
-    # then cryptsetup convert DEV --type luks1, then readd old keys and remove temp.
-    yes YES | cryptsetup luksFormat $(rootdev) $luks_file \
-                         --type luks1 -c aes-cbc-essiv:sha256 -s 256 || [[ $? == 141 ]]
-    yes "$lukspw" | \
-      cryptsetup luksAddKey --key-file $luks_file \
-                 $(rootdev) || [[ $? == 141 ]]
-    # background: Keyfile and password are treated just
-    # like 2 ways to input a passphrase, so we don't actually need to have
-    # different contents of keyfile and passphrase, but it makes some
-    # security sense to a really big randomly generated passphrase
-    # as much as possible, so we have both.
-    #
-    # This would remove the keyfile.
-    #    yes 'test' | cryptsetup luksRemoveKey /dev/... \
-      #                            /key/file || [[ $? == 141 ]]
-
-    cryptsetup luksOpen $(rootdev) $(root-cryptname) \
-               --key-file $luks_file
+    luks-setup $(rootdev)
 
     if [[ $SPECIAL_DISK ]]; then
       exit 0
@@ -548,7 +673,7 @@ else
 fi
 
 
-if $wipe && [[ $DISTRO != debianbuster_bootstrap ]]; then
+if $wipe && [[ $DISTRO != debianbullseye_bootstrap ]]; then
   # bootstrap distro doesn't use separate encrypted root.
   mount -o subvolid=0 $first_root_crypt /mnt
   # systemd creates subvolumes we want to delete.
@@ -567,12 +692,15 @@ if $wipe && [[ $DISTRO != debianbuster_bootstrap ]]; then
   # btrfs subvolume set-default \
     #       $(btrfs subvolume list . | grep "root_$DISTRO$" | awk '{print $2}') .
 
-  # no cow on the root filesystem. it's setup is fully scripted,
-  # if it's messed up, we will just recreated it,
-  # and we can get better perf with this.
-  # I can't remember exactly why, but this is preferable to mounting with
-  # -o nodatacow, I think because subvolumes inherit that.
-  chattr -Rf +C root_$DISTRO
+  # For raid systems, cow allows for error correction, for non-raid systems,
+  # protects root fs from having the plug pulled. Reprovisioning a root
+  # subvol is not my favorite thing to do.
+  # # no cow on the root filesystem. it's setup is fully scripted,
+  # # if it's messed up, we will just recreated it,
+  # # and we can get better perf with this.
+  # # I can't remember exactly why, but this is preferable to mounting with
+  # # -o nodatacow, I think because subvolumes inherit that.
+  # chattr -Rf +C root_$DISTRO
   cd /
   umount /mnt
 fi
@@ -585,7 +713,7 @@ btrfs subvolume set-default 0 /mnt # already default, just ensuring it.
 mkdir -p /mnt/grub2
 cp $FAI/distro-install-common/libreboot_grub.cfg /mnt/grub2
 
-if [[ $DISTRO == debianbuster_bootstrap ]]; then
+if [[ $DISTRO == debianbullseye_bootstrap ]]; then
   # this is just convenience for the libreboot_grub config
   # so we can glob the other ones easier.
   boot_vol=$DISTRO
@@ -608,10 +736,11 @@ grub-editenv /mnt/grubenv set did_fai_check=true
 grub-editenv /mnt/grubenv set last_boot=/$boot_vol
 umount /mnt
 
-if [[ $DISTRO == debianbuster_bootstrap ]]; then
+fstabstd=x-systemd.device-timeout=30s,x-systemd.mount-timeout=30s
+if [[ $DISTRO == debianbullseye_bootstrap ]]; then
   cat > /tmp/fai/fstab <<EOF
 $first_boot_dev  /  btrfs  noatime,subvol=$boot_vol  0 0
-$first_efi  /boot/efi  vfat          nofail,x-systemd.device-timeout=30s,x-systemd.mount-timeout=30s  0 0
+$first_efi  /boot/efi  vfat          nofail,$fstabstd  0 0
 EOF
   cat >/tmp/fai/disk_var.sh <<EOF
 BOOT_DEVICE="${short_devs[@]}"
@@ -620,11 +749,11 @@ EOF
 else
   # note, fai creates the mountpoints listed here
   cat > /tmp/fai/fstab <<EOF
-$first_root_crypt  /  btrfs          x-systemd.device-timeout=90s,x-systemd.mount-timeout=90s,noatime,subvol=root_$DISTRO$mopts  0 0
-$first_root_crypt  /mnt/root  btrfs  nofail,x-systemd.device-timeout=30s,x-systemd.mount-timeout=30s,noatime,subvolid=0$mopts  0 0
-$first_boot_dev  /boot  btrfs        nofail,x-systemd.device-timeout=30s,x-systemd.mount-timeout=30s,noatime,subvol=$boot_vol  0 0
-$first_efi  /boot/efi  vfat          nofail,x-systemd.device-timeout=30s,x-systemd.mount-timeout=30s  0 0
-$first_boot_dev  /mnt/boot  btrfs    nofail,x-systemd.device-timeout=30s,x-systemd.mount-timeout=30s,noatime,subvolid=0  0 0
+$first_root_crypt  /  btrfs $fstabstdopts,noatime,subvol=root_$DISTRO$mopts  0 0
+$first_root_crypt  /mnt/root  btrfs  nofail,$fstabstd,noatime,subvolid=0$mopts  0 0
+$first_boot_dev  /boot  btrfs        nofail,$fstabstd,noatime,subvol=$boot_vol  0 0
+$first_efi  /boot/efi  vfat          nofail,$fstabstd  0 0
+$first_boot_dev  /mnt/boot  btrfs    nofail,$fstabstd,noatime,subvolid=0  0 0
 EOF
   swaps=()
   rm -f /tmp/fai/crypttab
@@ -635,7 +764,7 @@ $(root-cryptname) $(rootdev)  none  keyscript=/root/keyscript,discard,luks,initr
 $(swap-cryptname) $(swapdev)  /dev/urandom  swap,cipher=aes-xts-plain64,size=256,hash=ripemd160
 EOF
     cat >> /tmp/fai/fstab <<EOF
-$(swap-cryptdev)  none  swap  nofail,x-systemd.device-timeout=30s,x-systemd.mount-timeout=30s,sw  0 0
+$(swap-cryptdev)  none  swap  nofail,$fstabstd,sw  0 0
 EOF
   done
 
@@ -651,6 +780,24 @@ ROOT_PARTITIONS="${root_devs[@]}"
 ROOT_PARTITION=\${ROOT_PARTITION:-$first_root_crypt}
 SWAPLIST=\${SWAPLIST:-"${swaps[@]}"}
 EOF
+
+  if [[ $HOSTNAME == kd ]]; then
+    # note, having these with keyscript and initramfs causes a luks error in fai.log,
+    # but it is safely ignorable and gets us the ability to just type our password
+    # in once at boot. A downside is that they are probably needed to be plugged in to boot.
+    cat >>/tmp/fai/crypttab <<EOF
+crypt_dev_ata-Samsung_SSD_870_QVO_8TB_S5VUNG0N900656V-part${even_bign} /dev/disk/by-id/ata-Samsung_SSD_870_QVO_8TB_S5VUNG0N900656V-part7  none  keyscript=decrypt_keyctl,discard,luks,initramfs
+crypt_dev_ata-TOSHIBA_MD04ACA500_84R2K773FS9A-part1 /dev/disk/by-id/ata-TOSHIBA_MD04ACA500_84R2K773FS9A-part1  none  keyscript=decrypt_keyctl,discard,luks,initramfs
+crypt_dev_ata-ST6000DM001-1XY17Z_Z4D29EBL-part1 /dev/disk/by-id/ata-ST6000DM001-1XY17Z_Z4D29EBL-part1  none  keyscript=decrypt_keyctl,discard,luks,initramfs
+EOF
+    cat >> /tmp/fai/fstab <<EOF
+# r7 = root partition7. it isnt actually #7 anymore, not a great name, but whatever
+/dev/mapper/crypt_dev_ata-Samsung_SSD_870_QVO_8TB_S5VUNG0N900656V-part${even_bign}  /mnt/r7  btrfs  nofail,$fstabstd,noatime,compress=zstd,subvolid=0  0 0
+/dev/mapper/crypt_dev_ata-TOSHIBA_MD04ACA500_84R2K773FS9A-part1  /mnt/rust1  btrfs  nofail,$fstabstd,noatime,compress=zstd,subvolid=0  0 0
+/dev/mapper/crypt_dev_ata-ST6000DM001-1XY17Z_Z4D29EBL-part1  /mnt/rust2  btrfs  nofail,$fstabstd,noatime,compress=zstd,subvolid=0  0 0
+EOF
+  fi
+
 fi
 
 # initial setup of extra data fs, mounted,
@@ -658,15 +805,3 @@ fi
 # chattr +C nocow
 # chown iank.iank nocow
 
-if [[ $HOSTNAME == kd ]]; then
-  cat >>/tmp/fai/crypttab <<EOF
-crypt_dev_ata-Samsung_SSD_870_QVO_8TB_S5VUNG0N900656V-part6 /dev/disk/by-id/ata-Samsung_SSD_870_QVO_8TB_S5VUNG0N900656V-part6  none  keyscript=decrypt_keyctl,discard,luks,initramfs
-crypt_dev_ata-TOSHIBA_MD04ACA500_84R2K773FS9A-part1 /dev/disk/by-id/ata-TOSHIBA_MD04ACA500_84R2K773FS9A-part1  keyscript=decrypt_keyctl,discard,luks,initramfs
-EOF
-  cat >> /tmp/fai/fstab <<EOF
-/dev/mapper/crypt_dev_ata-Samsung_SSD_870_QVO_8TB_S5VUNG0N900656V-part6  /d  btrfs  nofail,x-systemd.device-timeout=30s,x-systemd.mount-timeout=30s,noatime,compress=zstd,subvol=nocow  0 0
-# r6 = root partition6
-/dev/mapper/crypt_dev_ata-Samsung_SSD_870_QVO_8TB_S5VUNG0N900656V-part6  /mnt/r6  btrfs  nofail,x-systemd.device-timeout=30s,x-systemd.mount-timeout=30s,noatime,compress=zstd,subvolid=0  0 0
-/dev/mapper/crypt_dev_ata-TOSHIBA_MD04ACA500_84R2K773FS9A-part1  /mnt/rust  btrfs  nofail,x-systemd.device-timeout=30s,x-systemd.mount-timeout=30s,noatime,compress=zstd,subvolid=0  0 0
-EOF
-fi